
C     Catalog asteroid prediction program with satellite ephemeris input
C     This program requires an input file named ephem.tem which is output
C     from sateph
C
C      f77 -o satcatprd satcatprd.for lhwsub.a /home/elgb/fortran/tedsub.a
C
      IMPLICIT REAL*8 (A-H,O-Z)
      CHARACTER*1 DCODE,MAGTYPE,OUTMODE,AVFLG,FF
      CHARACTER*4 CATCODE
      CHARACTER*13 STRNAME
      CHARACTER*4 MNTH(12)
      CHARACTER*25 NAME
      CHARACTER*7 REF
      CHARACTER*80 IDEN
      CHARACTER*16 OUTR
      CHARACTER*15 OUTD
      LOGICAL*1 BATCH,RFLG,IFIRST,L1TRUE,LINUX
      REAL*4 VMAG
      REAL*8 JD,JDS,JD0,JDMID,JDUT,JDP(11)
      INTEGER*4 SYSTEM
      CHARACTER*1 FDISP
      DIMENSION RA(11),DEC(11),TTSE(3),TETA(3),
     1QTSE(3),QETA(3),ARG3(3),TSOL(3),QSOL(3)
     1,TSE(11),ETA(11),ICUMD(12),SEL(11)
      COMMON/CONST/RACTR,DECCTR,SDCTR,CDCTR,CON,CONA,TSEMIN,TSEMAX,
     1ETAMIN,ETAMAX,NST,CATCODE
      COMMON/MAG/FMAGLIM
      COMMON/PLECOM/IPV
      COMMON/HOSTTYPE/LINUX
      DATA L1TRUE/.TRUE./
      DATA NLINES/0/
      DATA GK/.01720209895D+0/
      DATA DRAD/.017453292519943295D+0/
      DATA AU/1.495978706911D+11/
      DATA CC/299792458.D0/
      DATA ICUMD/0,31,59,90,120,151,181,212,243,273,304,334/
      DATA MNTH/' Jan',' Feb',' Mar',' Apr',' May',' Jun',' Jul',
     1' Aug',' Sep',' Oct',' Nov',' Dec'/
      DATA ARG3/-0.5D+00,0.D+00,0.5D+00/
      NU=1
      CALL WHICHHOST(NU)
      FF=CHAR(12)
C---  Derived constants...
C---  Speed of light in Au/d
      SPDLT=CC/AU*86400.D0
C---  And days per AU
      TL=1.D0/SPDLT
C---  Heliocetric gravitational constant (mu -- m^3 s^-2)
      GRAVCON=AU**3*GK**2/86400.D0**2
C---  Constant of gravitational retardation (AU^-1)
      CCON=GRAVCON/(CC**2*AU)
      CON=3.141592653589793238D0/180.D+00
      TWOPI=6.283185307179586477D0
      TESMIN=7.272205217D-05          !15 ARC SEC IN RADIANS
      WIDTH=2.D+00*TESMIN          !30 ARC-SEC
      DELTA=40.D+00*TESMIN          !10 ARC-MIN
      CONA=CON*15.D+00
      NFILE=1
      NVALS=11
         WRITE(6,5000)
 5000    FORMAT('GAIA/HIP2 catalog occultation prediction program'/)
         WRITE(6,4300)
4300     FORMAT('Enter limiting magnitude: ',$)
         READ(5,4301)FMAGLIM
4301     FORMAT(F10.0)
      WRITE(6,8080)
8080  FORMAT('Enter minimum separation (arcsec), '
     1,'<CR> for default: ',$)
      READ(5,8081)DMINUSE
8081  FORMAT(F10.0)
      IF(DMINUSE.EQ.0.D0) DMINUSE=5.D0
C     Open output file
      OPEN(UNIT=3,FILE='satcatprd.out',STATUS='UNKNOWN')
C     Open ephemeris file
      OPEN(UNIT=8,FILE='ephem.tem',ACCESS='DIRECT',RECL=83
     1,STATUS='OLD',ERR=1916)
      GO TO 1917
1916  WRITE(6,1918)
1918  FORMAT('Data file ephem.tem not found')
      CALL EXIT(0)
1917  CONTINUE
C---  Header info
      READ(8,REC=2) NAME
      READ(8,REC=3) IDEN,BATCH,OUTMODE,FDISP
      READ(8,REC=4) JD0,NUMEPH,UNITS
      CALL CALEN(JD0,IYRS,IMOS,IDS,IHS,IMS,SS)     !START DATE
      READ(8,REC=5) REF,DIAM,HCOEF,GCOEF,BMV
      OPEN(UNIT=9,FILE='events.tem',FORM='UNFORMATTED',STATUS='UNKNOWN')
      OPEN(UNIT=16,FILE='apul.dat',STATUS='UNKNOWN',
     1ACCESS='APPEND',FORM='UNFORMATTED')
      OPEN(UNIT=11,STATUS='SCRATCH',ACCESS='DIRECT',RECL=72)
C---  Read info for this object
      WRITE(3,1341) NAME
      WRITE(6,1341) NAME
 1341 FORMAT('Appulses by ',A/)
      DAYST=IDS+(IHS+IMS/60.D+00+SS/3600.D+00)/24.D+00
      WRITE(3,1349) IYRS,MNTH(IMOS),DAYST
 1349 FORMAT('Start date: ',I4,A,1X,F6.3/)
      WRITE(3,1350) FMAGLIM
1350  FORMAT('GAIA/HIP2 catalog search. Limiting mag: ',F5.1/)
      WRITE(3,7111)
 7111 FORMAT(6X,'Star',9X,'Minimum',15X,'Date',16X,'Star to',11X,'RA'
     1,5X,'(2000.0)',5X,'Dec',10X,7X,'Solar')
      WRITE(3,7112)
 7112 FORMAT(5X,'Number',7X,'Separation',12X,'(E.T.)',15X,
     1'Asteroid',13X,'(Epoch of Event)',13X,'Mag',5X,'Elong')
      WRITE(3,7113)
 7113 FORMAT(19X,'(arcsec)',33X,' Pos Ang ')
      WRITE(3,7104)
7104  FORMAT(' ')
      IFIRST=.FALSE.
      OPEN(UNIT=7,STATUS='SCRATCH',ACCESS='DIRECT',RECL=40)
      NREAD=6
106   DO JJ=1,11
        NREAD=NREAD+1
        IF(NREAD.EQ.NUMEPH+6) GO TO 37          !OUT OF DATA
        READ(8,REC=NREAD) JD,RA(JJ),DEC(JJ),RG,SEL(JJ)
        JDP(JJ)=JD
        IF(JJ.EQ.6) THEN
          DIST=RG
          JDMID=JD
          CALL CALEN(JD,IY,IMO,ID,IH,IMIN,SEC)
         ELSEIF(JJ.EQ.1) THEN
          CALL CALEN(JD,IYS,IMOS,IDS,IHS,IMS,SS)
         ELSEIF(JJ.EQ.11) THEN
          CALL CALEN(JD,IYEND,IMOEND,IDEND,IHEND,IMEND,SEND)
         ENDIF
      ENDDO
         DRA=0.D0
         DDEC=0.D0
C---  Compute maximum acceptable separation between object and star
C---  as the larger of 5 arc-sec or the size of two Earth radii at
C---  the object's distance plus the semi-diameter of the object
      OBSEC=206265.D+00*DIAM/(DIST*1.495978706911D+08*2.D+00)
      DISTM=DMAX1(DMINUSE,17.65D+00/DIST+OBSEC)
C---  Convert to radians
      DISTM=DISTM/206265.D+00
      DISTM2=DISTM*DISTM
C---  Find mean of maximum and minimum RA and DEC and define it as
C---  "plate center"
      DECMIN=1.D+30
      DECMAX=-1.D+30
      DO I=1,NVALS
         IF(DEC(I).LT.DECMIN) DECMIN=DEC(I)
         IF(DEC(I).GT.DECMAX) DECMAX=DEC(I)
      ENDDO
      DO I=2,NVALS
         IF(RA(I)-RA(I-1).GT.+180.D+00) RA(I)=RA(I)-360.D+00
         IF(RA(I)-RA(I-1).LT.-180.D+00) RA(I)=RA(I)+360.D+00
      ENDDO
      RAMIN=1.D+30
      RAMAX=-1.D+30
      DO I=1,NVALS
         IF(RA(I).LT.RAMIN) RAMIN=RA(I)
         IF(RA(I).GT.RAMAX) RAMAX=RA(I)
      ENDDO
      RACTR=(RAMAX+RAMIN)/2.D+00
      DECCTR=(DECMAX+DECMIN)/2.D+00
C---  Assume a plate scale of 1.0 and convert RA,DEC to TSE,ETA
      DECCTR=DECCTR*CON
      RACTR=RACTR*CON
      SDCTR=DSIN(DECCTR)
      CDCTR=DSQRT(1.D+00-SDCTR*SDCTR)
      DO I=1,NVALS
         RAA=RA(I)*CON
         DECC=DEC(I)*CON
         SD=DSIN(DECC)
         CD=DSQRT(1.D+00-SD*SD)
         SDA=DSIN(RAA-RACTR)
         CDA=DCOS(RAA-RACTR)
         FACT=1.D+00/(SDCTR*SD+CDCTR*CD*CDA)
         TSE(I)=-CD*SDA*FACT
         ETA(I)=(CDCTR*SD-SDCTR*CD*CDA)*FACT
      ENDDO
C---  Find min and max of TSE and ETA
      CALL MINMAX(TSE,NVALS,TSEMIN,TSEMAX)
      CALL MINMAX(ETA,NVALS,ETAMIN,ETAMAX)
C     Increase area by 10 arcmin or 4*DISTM on a side whichever is larger
      DELTAA=MAX(DELTA,4.D+00*DISTM)
      TSEMIN=TSEMIN-DELTAA
      TSEMAX=TSEMAX+DELTAA
      ETAMIN=ETAMIN-DELTAA
      ETAMAX=ETAMAX+DELTAA
C---  Find stars on "plate".  Put in scratch file open on unit 7.
 9000 NST=0
C---  Use the time in the middle of the "plate"
      JDUT=(JDP(1)+JDP(11))/2.D0
      CATCODE='GA  '
      CALL GAIASRCH(JDUT)
      OPEN(UNIT=1,FILE='/tibro/data/catalogs/hip2.cat',STATUS='OLD'
     1,ACCESS='DIRECT',RECL=36)
      CATCODE='HP  '
      CALL HIP2SRCH(JDUT)
      CLOSE(UNIT=1)
C---  Fine analysis--fit three points at a time to a quadratic.
      NOC=0
      DO 117 I=1,9,2
      IX=0
      DO 118 J=I,I+2
      IX=IX+1
      TTSE(IX)=TSE(J)
      TETA(IX)=ETA(J)
  118 TSOL(IX)=SEL(J)
C     FIT QUADRATICS TO TSE,ETA, SOL EL
      CALL POLFIT(ARG3,TTSE,3,3,QTSE,CHISQ)
      CALL POLFIT(ARG3,TETA,3,3,QETA,CHISQ)
      CALL POLFIT(ARG3,TSOL,3,3,QSOL,CHISQ)
      EMIN=DMIN1(TETA(1),TETA(2),TETA(3))
      EMAX=DMAX1(TETA(1),TETA(2),TETA(3))
      TSMIN=DMIN1(TTSE(1),TTSE(2),TTSE(3))
      TSMAX=DMAX1(TTSE(1),TTSE(2),TTSE(3))
C     TEST THAT ASTEROID DOES NOT GO WITHIN WIDTH OR 2*DISTM OF
C     PLATE BNDY, WHICHEVER IS LARGER
      WID=MAX(WIDTH,2.D+00*DISTM)
      TIM=-QTSE(2)/(2.D+00*QTSE(3))     !TIME OF MIN OR MAX
      IF(ARG3(1).GT.TIM.OR.ARG3(3).LT.TIM) GO TO 401     !DOES NOT OCCUR HERE
      VAL=PLY8E(TIM,2,QTSE)
      TSMIN=DMIN1(TSMIN,VAL)
      TSMAX=DMAX1(TSMAX,VAL)
      IF(TSMAX.GT.TSEMAX-WID.OR.TSMIN.LT.TSEMIN+WID) GO TO 508
  401 TIM=-QETA(2)/(2.D+00*QETA(3))
      IF(ARG3(1).GT.TIM.OR.ARG3(3).LT.TIM) GO TO 500
      VAL=PLY8E(TIM,2,QETA)
      EMIN=DMIN1(EMIN,VAL)
      EMAX=DMAX1(EMAX,VAL)
      IF(EMAX.GT.ETAMAX-WID.OR.EMIN.LT.ETAMIN+WID) GO TO 508
      GO TO 500
  508 TSIZE=TSEMAX-TSEMIN
      ESIZE=ETAMAX-ETAMIN
      TEXPAN=0.1D+00*TSIZE
      EEXPAN=0.1D+00*ESIZE
      IF(TEXPAN.LT.WID) TEXPAN=WID
      IF(EEXPAN.LT.WID) EEXPAN=WID
      ETAMAX=ETAMAX+EEXPAN
      ETAMIN=ETAMIN-EEXPAN
      TSEMIN=TSEMIN-TEXPAN
      TSEMAX=TSEMAX+TEXPAN
      DEND=IDEND+(IHEND+IMEND/60.D+00+SEND/3600.D+00)/24.D+00
      DST=IDS+(IHS+IMS/60.D+00+SS/3600.D+00)/24.D+00
      WRITE(3,7100) IYS,MNTH(IMOS),DST,IYEND,MNTH(IMOEND),DEND
 7100 FORMAT(/'Asteroid outside of plate area.  Restart ',
     1'interval ',I4,A,1X,F6.3,' to ',I4,A,1X,F6.3/)
      WRITE(6,7100) IYS,MNTH(IMOS),DST,IYEND,MNTH(IMOEND),DEND
      GO TO 9000
C     EXPAND AREA BY 15% OR 1.2*DISTM OR 2*TESMIN ON EACH SIDE
C     WHICHEVER IS LARGER
500   TSIZE=TSMAX-TSMIN
      ESIZE=EMAX-EMIN
      TEXPAN=.15D+00*TSIZE
      EEXPAN=.15D+00*ESIZE
      TEXPAN=MAX(TEXPAN,2.D+00*TESMIN,1.2D+00*DISTM)
      EEXPAN=MAX(EEXPAN,2.D+00*TESMIN,1.2D+00*DISTM)
      TSMIN=TSMIN-TEXPAN
      TSMAX=TSMAX+TEXPAN
      EMIN=EMIN-EEXPAN
      EMAX=EMAX+EEXPAN
C     READ IN THE STARS AND FIND MIN DISTANCE OF EACH STAR FROM ASTEROID
      DO 30 J=1,NST
      READ(7,REC=J) CATCODE,STRNAME,XSTAR,YSTAR,VMAG,MAGTYPE
      IF(VMAG.LT.16.D0.OR.VMAG.GT.FMAGLIM) GO TO 30
C     PRELIMINARY TEST FOR CLOSENESS
      IF(TSMIN.LE.XSTAR.AND.TSMAX.GE.XSTAR) GO TO 40
      GO TO 30
   40 IF(EMIN.LE.YSTAR.AND.EMAX.GE.YSTAR) GO TO 50
      GO TO 30
C     COEFFICIENTS OF QUADRATIC EQN IN ARG3
   50 A=3.D+00*(QTSE(2)*QTSE(3)+QETA(2)*QETA(3))
      B=QTSE(2)**2+2.D+00*(QTSE(1)-XSTAR)*QTSE(3)
     1+QETA(2)**2+2.D+00*(QETA(1)-YSTAR)*QETA(3)
      C=(QTSE(1)-XSTAR)*QTSE(2)+(QETA(1)-YSTAR)*QETA(2)
C     COMPUTE THE ROOTS
      AUX=B*B-4.D+00*A*C
      IF(AUX.LT.0.D+00) GO TO 30
      AUX=DSQRT(AUX)
      AUX1=1.D+00/(2.D+00*A)
      R1=(-B+AUX)*AUX1
      R2=(-B-AUX)*AUX1
      RFLG=.FALSE.
C     SELECT CORRECT ROOT BY TESTING BOUNDS IN THE TIME ARG
      IF(R1.GT.0.5D+00.OR.R1.LT.-0.5D+00) GO TO 121
      TMIN=R1
      XROOT=R2
      GO TO 123
121   IF(R2.GT.0.5D+00.OR.R2.LT.-0.5D+00) GO TO 30
      TMIN=R2
      XROOT=R1
C     COMPUTE ASTEROID TSE,ETA, SOL EL AT TMIN
  123 TSEM=PLY8E(TMIN,2,QTSE)
      ETAM=PLY8E(TMIN,2,QETA)
      SELM=PLY8E(TMIN,2,QSOL)
C     TEST AGAINST 15 ARCSEC**2
      DMIN2=(TSEM-XSTAR)**2+(ETAM-YSTAR)**2
      IF(DMIN2.GT.DISTM2) GO TO 3001
C---  The minimum was found with a derivative.  Make sure
C---  we are not seeing a maximum by checking the second derivative
      DERIV2=12.D0*(QTSE(3)**2+QETA(3)**2)*TMIN**2
     1       +12.D0*(QTSE(3)*QTSE(2)+QETA(3)*QETA(2))*TMIN
     1       +4.D0*(QTSE(3)*(QTSE(1)-XSTAR)+QETA(3)*(QETA(1)-YSTAR))
     1       +2.D0*(QTSE(2)**2+QETA(2)**2)
      IF(DERIV2.LT.0.D0) GO TO 3001
C     DATE OF CLOSEST APPROACH
      DAYS=((I-1)+(TMIN+0.5D+00)*2.D+00)*UNITS
C     PA at closest approach
      CALL PANG(ANGMIN,XSTAR,YSTAR,TSEM,ETAM,0)
      CALL JULIAN(IYS,IMOS,IDS,IHS,IMS,SS,JDS)
      JDS=JDS+DAYS
      DIS=3600.D+00*DSQRT(DMIN2)/CON
      RASTR=DATAN(-XSTAR/(CDCTR-YSTAR*SDCTR))+RACTR
      DECSTR=-XSTAR/(DSIN(RASTR-RACTR)*(SDCTR+YSTAR*CDCTR))
      DECSTR=DATAN(1.D+00/DECSTR)
         RAAST=DATAN(-TSEM/(CDCTR-ETAM*SDCTR))+RACTR
         DECAST=-TSEM/(DSIN(RAAST-RACTR)*(SDCTR+ETAM*CDCTR))
         DECAST=DATAN(1.D+00/DECAST)
         WRITE(16) NAME,STRNAME,JDS,RASTR,DECSTR,RAAST
     1  ,DECAST,VMAG,MAGTYPE,CATCODE
      DCODE='S'
      IF(ETAM.GT.YSTAR) DCODE='N'
      AVFLG=' '
      NOC=NOC+1
      WRITE(11,REC=NOC) JDS,DIS,CATCODE,STRNAME,RASTR,DECSTR
     1,SELM,VMAG,MAGTYPE,DCODE,ANGMIN,AVFLG
C     CHECK ON OTHER ROOT JUST IN CASE BOTH ARE IN RANGE
 3001 IF(RFLG) GO TO 30
      IF(XROOT.GT.0.5D+00.OR.XROOT.LT.-0.5D+00) GO TO 30
      RFLG=.TRUE.
      TMIN=XROOT
      GO TO 123
   30 CONTINUE
 117  CONTINUE
C---  Remove duplicates, clean up and sort into date order
      IF(NOC.NE.0) THEN
         CALL SORT(NOC)
         CALL CLEAN(NOC)
      ENDIF
      DO 7090 JJ=1,NOC
      READ(11,REC=JJ) JDS,DIS,CATCODE,STRNAME,RASTR,DECSTR,SELM
     1,VMAG,MAGTYPE,DCODE,ANGMIN,AVFLG
      CALL CALEN(JDS,IYO,IMOO,IDO,IHO,IMO,SO)
      FDAYS=IDO+(IHO+IMO/60.D+00+SO/3600.D+00)/24.D+00
      RASS=RASTR
      RASTR=RASTR/CONA
      IF(RASTR.LT.0.D+00) RASTR=RASTR+24.D+00
      IF(RASTR.GE.24.D+00) RASTR=RASTR-24.D+00
      IF(RASS.LT.0.D+00) RASS=RASS+TWOPI
      IF(RASS.GE.TWOPI) RASS=RASS-TWOPI
      CALL HDOUT(RASTR,6,'H',' ',OUTR)
      CALL HDOUT(DECSTR/CON,5,'D',' ',OUTD)
      WRITE(3,128)CATCODE,STRNAME,AVFLG,DIS,IYO,MNTH(IMOO),FDAYS,ANGMIN,
     1DCODE,OUTR,OUTD,VMAG,MAGTYPE,SELM
  128 FORMAT(A,A,A,2X,F5.1,10X,I4,A,F9.5,11X,F5.1,'(',A,')',3X
     1,A,3X,A,3X,F5.2,A,3X,F5.1)
      WRITE(6,187)CATCODE,STRNAME,AVFLG,DIS,DCODE,IYO,MNTH(IMOO),
     1FDAYS,MAGTYPE,VMAG,SELM
  187 FORMAT(A,A,A,1X,F5.1,' arcsec ',A,2X,I4,
     1A,1X,F5.2,3X,A,'mag ',F5.2,3X,'Sol El ',F5.1)
      WRITE(9) CATCODE,STRNAME,RASS,DECSTR,IYO,IMOO,FDAYS,VMAG
     1,MAGTYPE,AVFLG,DRA,DDEC
      NLINES=NLINES+1
      IF(MOD(NLINES,10).EQ.0) WRITE(3,7091)
7091  FORMAT(' ')
      IF(MOD(NLINES,40).EQ.0) THEN
           NLINES=0
           WRITE(3,7092) FF
7092       FORMAT(A)
           WRITE(3,7111)
           WRITE(3,7112)
           WRITE(3,7113)
      ENDIF
7090  CONTINUE
C     EXIT IF END DATE REACHED OR PASSED
      DEND=IDEND+(IHEND+IMEND/60.D+00+SEND/3600.D+00)/24.D+00
      WRITE(6,9999)IYEND,MNTH(IMOEND),DEND
 9999 FORMAT('Complete thru: ',I4,A,1X,F6.3)
      NREAD=NREAD-1
      GO TO 106
   37 DEND=IDEND+(IHEND+IMEND/60.D+00+SEND/3600.D+00)/24.D+00
      WRITE(3,1340) IYEND,MNTH(IMOEND),DEND
 1340 FORMAT(/'End date: ',I4,A,1X,F6.3)
      CLOSE(UNIT=7)
      IF(FDISP.EQ.'O') THEN
         CALL EXIT(0)
      ELSE
         IF(FDISP.EQ.'P') THEN
            II=SYSTEM('mpage -o -l1 satcatprd.out')
         ELSEIF(FDISP.EQ.'D') THEN
            II=SYSTEM('mpage -o -l1 satcatprd.out')
            II=SYSTEM('rm catprd.out')
         ENDIF
         CALL EXIT(0)
      ENDIF
      CALL EXIT(0)
      END
